package com.franckbarbier.Completion;

public class Table_tennis {

    private com.pauware.pauware_engine.Core.AbstractState _Ping;
    private com.pauware.pauware_engine.Core.AbstractState _Pong;
    private com.pauware.pauware_engine.Core.AbstractState _Player;
    private com.pauware.pauware_engine.Core.AbstractStateMachine _Table_tennis_state_machine;

    private void init_behavior() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Ping = new com.pauware.pauware_engine.Core.State("Ping");
        _Ping.inputState();
        _Pong = new com.pauware.pauware_engine.Core.State("Pong");
        _Pong.set_entryAction(this, "up");
        _Pong.doActivity(this, "hit");
        _Pong.set_exitAction(this, "down");
        /**
         * Completion transitions are triggered when leaving output states
         * *ONLY*!
         */
        _Pong.outputState();
        /**
         *
         */
        // 'null' creates a fictious state:
        _Player = _Pong.and(new com.pauware.pauware_engine.Core.State(null)).name("Player");
        _Table_tennis_state_machine = new com.pauware.pauware_engine.Core.StateMachine(_Ping.xor(_Player), "Table tennis", com.pauware.pauware_engine.Core.AbstractStateMachine.Don_t_show_on_system_out, new com.pauware.pauware2web.PauWare2Web_client());
    }

    public void start() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Table_tennis_state_machine.fires("ball", _Ping, _Pong);
        _Table_tennis_state_machine.fires(com.pauware.pauware_engine.Core.AbstractState.Completion, _Pong, _Ping);
        _Table_tennis_state_machine.start();
    }

    public void stop() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Table_tennis_state_machine.stop();
    }

    public Table_tennis() throws com.pauware.pauware_engine.Exceptions.State_exception {
        init_behavior();
    }

    public void ball() throws com.pauware.pauware_engine.Exceptions.State_exception {
        _Table_tennis_state_machine.run_to_completion("ball");
    }

    public void up() {
        System.out.println("'up' executed...");
    }

    public void hit() {
        try {
            Thread.sleep(10);
        } catch (InterruptedException ex) {
            ex.printStackTrace();
        }
        System.out.println("'hit' ends...");
    }

    public void down() {
        System.out.println("'down' executed...");
    }

    public static void main(String args[]) {
        try {
            Table_tennis tt = new Table_tennis();
            tt.start();
            tt.ball();
            try {
                Thread.sleep(10); // Fake delay...
            } catch (InterruptedException ex) {
                ex.printStackTrace();
            }
            tt.stop();
        } catch (Throwable t) {
            t.printStackTrace();
        }
    }
}
